using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Pipeline.Campaign.Cqrs;

public record DeleteExpenseCommand(string Id) : IRequest<bool>;

public class DeleteExpenseHandler : IRequestHandler<DeleteExpenseCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteExpenseHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteExpenseCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.Expense
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.Expense.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}